<?php
/* **************************************************************************** *

 * cor-drive-contents.php							*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing files at drive.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */
require "cor-contents.php";

class DriveContents extends Contents {

    public $page = array ( "text" => "" );
    private $cordrive;
    private $corsourceeditor;

    public function __construct ()
    {
    	
    	$this -> cordrive = Localization::session () -> getFile ( "cor-drive", false );
    	$this -> corsourceeditor = Localization::session () -> getFile ( "cor-source-editor", false );
    	
    	if ( isset ( $_GET [ "contentdir" ], $_GET [ "side" ] ) && ( $_GET [ "side" ] == "left" || $_GET [ "side" ] == "right" )  ) {
    	    $this -> page [ "text" ] .= $this -> showDir ( $_GET [ "contentdir" ], $_GET [ "side" ] );
    	} else {

	    // gets php code common to all pages of contents
    	    parent::__construct ();

            $this -> page [ "text" ] .= '<span id="webcontentsHelp" class="helpmessagebox">
            Poklepejte na složku (dvojklik) pro otevřění;
            Klepněte pravým tlačítkem na soubor pro zobrazení dalších akcí;
            CSS a XHTML můžete uložit pomocí CTRL+S;
            Albireo umožňuje nahrát na server několik souborů najednou;
            Albireo podporuje různé formáty souborů včetně PDF, JPG nebo AVI;
            Ve složce Domů má každý uživatel svoji osobní složku;
            Návody na používání systému Albire naleznete na webu <a href="http://www.albireo.eu/tutorialy-pro-albireo" title="návody">www.albireo.eu</a>
            </span>';

            $disk_free_space = (int) ( @disk_free_space ( "." ) / 1000000 );
            $disk_total_space = (int) ( @disk_total_space ( "." ) / 1000000 );
            if ( $disk_free_space > 0 && $disk_total_space > 0 ) {
                $this -> page [ "text" ] .= '<br /><strong>'. _( "Místo na disku" ) .':</strong> '. $disk_free_space .' MB '. _( "z" ) .' '. $disk_total_space .' MB';
            }

	    // uploads file on server
    	    if ( isset ( $_FILES [ "file" ], $_POST [ "access" ], $_POST [ "usergroup" ], $_POST [ "access" ], $_POST [ "parent" ] ) ) {
    	    	$this -> uploadFile ();
    	    	$this -> page [ "text" ] .= '<script type="text/javascript">
	    	    showAndHide ( \'upload\' );
	    	</script>';
    	    }

	    $this -> page [ "text" ] .= '
	    <script type="text/javascript" src="scripts/cor-source-editor.js"></script>
        <script type="text/javascript" src="http://code.google.com/intl/cs/apis/gears/gears_init.js"></script>
        <script type="text/javascript" src="scripts/cor-googlegears.js"></script>
        <script type="text/javascript" src="scripts/cor-googlegears-uploader.js"></script>
	    <div class="floatLeft">
	    <a href="#" class="cor-button-small cor-upload" onclick="directoryContent.destroyObjectActions();openUploaderDialogue(directoryContent.leftDirId);return false;"><span>'. _( 'Nahrát' ) .'</span></a><br />
	    <a href="#" class="cor-button-small cor-createfile" onclick="directoryContent.destroyObjectActions();ajaxWidthDialogue(\''. $this -> cordrive .'.xml?action=createfile&#038;dirid=\'+directoryContent.leftDirId,550);return false;"><span>'. _( 'Vytvořit' ) .'</span></a><br />
	    <a href="#" class="cor-button-small cor-foldernew" onclick="directoryContent.destroyObjectActions();ajaxWidthDialogue(\''. $this -> cordrive .'.xml?action=newfolder&#038;dirid=\'+directoryContent.leftDirId,550);return false;"><span>'. _( 'Nová složka' ) .'</span></a>
	    </div>

	    <div class="floatRight">
    	    <a href="#" class="cor-button-small cor-upload" onclick="directoryContent.destroyObjectActions();openUploaderDialogue(directoryContent.rightDirId);return false;"><span>'. _( 'Nahrát' ) .'</span></a><br />
    	    <a href="#" class="cor-button-small cor-createfile" onclick="directoryContent.destroyObjectActions();ajaxWidthDialogue(\''. $this -> cordrive .'.xml?action=createfile&#038;dirid=\'+directoryContent.rightDirId,550);return false;"><span>'. _( 'Vytvořit' ) .'</span></a><br />
    	    <a href="#" class="cor-button-small cor-foldernew" onclick="directoryContent.destroyObjectActions();ajaxWidthDialogue(\''. $this -> cordrive .'.xml?action=newfolder&#038;dirid=\'+directoryContent.rightDirId,550);return false;"><span>'. _( 'Nová složka' ) .'</span></a>
    	    </div>';

	    $this -> page [ "text" ] .= '
    	    <div id="cor-contentdir-head" onclick="directoryContent.destroyObjectActions();">
    	    <div class="floatLeft cor-contentdir"><div id="leftContentWindow">'. $this -> showDir ( "/", "left" ) .'</div></div>
    	    <div class="floatRight cor-contentdir"><div id="rightContentWindow">'. $this -> showDir ( "/", "right" ) .'</div></div>
    	    </div>

    	    <img class="invisible" src="styles/cor-admin/folder_open.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/createfile-over.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/upload-over.jpg" alt="hidden part of content" />
    	    <script type="text/javascript">
    	    	// sets main directory as root (user can`t create anything in root diretory)
    	    	directoryContent.leftDirId = "/";
    	    	directoryContent.rightDirId = "/";
    	    </script>
    	    <hr class="cleaner" />';

    	}
    } // end __construct

    private function showDir ( $dir, $side )
    {
    	$content = "";

    	if ( $dir == "/" ) {

    	    $directory = Database::connection () -> fetchall_assoc ( "SELECT * FROM `drivefilesv2` WHERE url='/';" );

    	    $directory [ 1 ] [ "title" ] = "Obrázky";
            $directory [ 2 ] [ "title" ] = "Styly";
    	    $directory [ 3 ] [ "title" ] = "XHTML";
            $directory [ 0 ] [ "title" ] = "Domů";

	    	$content .= $this -> createHTMLDir ( $directory [ 1 ], $side );
            $content .= $this -> createHTMLDir ( $directory [ 3 ], $side );
            $content .= $this -> createHTMLDir ( $directory [ 2 ], $side );
            $content .= $this -> createHTMLDir ( $directory [ 0 ], $side );

    	} else {

            $slash = strrpos ( substr ( $dir, 0, -1 ), "/" );
            $opened_dir_url = substr ( $dir , 0, $slash+1 );
            $opened_dir_name = substr ( $dir , $slash+1, -1 );
            //$content .= "parent".$dir." ".$slash." ".$opened_dir_url." ".$opened_dir_name;
    	    $opened_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$opened_dir_url' AND `physicalname`='$opened_dir_name' ;" );
    	    $opened_dir = ( is_array ( $opened_dir ) ) ? $opened_dir : array ( "author" => 1, "groupid" => 1, "access" => "ww0" );
    	    // access checking ///////////////////////////////////////////////////////////
            if ( !SecurityTools::check_read ( $opened_dir [ "access" ], $opened_dir [ "author" ], $opened_dir [ "groupid" ] ) ) {
                Error::ticket () -> notice ( 'cor00028', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
            }
            //////////////////////////////////////////////////////////////////////////////
    	    $content .= '<a href="#" class="cor-button cor-dirButton" onclick="return false;" oncontextmenu="return false;" ondblclick="directoryContent.getDirectoryContent(\'xml.php?page='. Tools::getPage () .'&#038;contentdir='. $opened_dir_url .'&#038;side='. $side. '\',\''. $side .'\',\''. $opened_dir_url .'\');"><span>'. _( '..nahoru' ) .'</span></a>';
    	    $content .= $this -> readFolder ( $dir, $opened_dir_name, $side );

    	}

    	return $content;
    } // end showDir

    private function readFolder ( $url, $name, $side ) {

        $path = substr( $url, 1 );
        $folder = "";
        $directory = opendir ( $path );
        $folders = array ();
        $files = array ();

    	while ( $file = readdir ( $directory ) ) {
    	     if ( $file != "." && $file != ".." ) {
    	     	if ( is_dir ( $path . "/" . $file ) ) {
    	     	    $folders [] = $file;
    	     	} else {
    	     	    $files [] = $file;
    	     	}
    	     }
    	}

    	closedir ( $directory );
    	sort ( $folders );
    	sort ( $files );

    	foreach ( $folders as $this_folder ) {
    	    $row = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$this_folder';" );
    	    $data = ( is_array ( $row ) ) ? $row : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $this_folder, "url" => $url );
    	    $folder .= $this -> createHTMLDir ( $data, $side );
    	}

    	foreach ( $files as $this_file ) {
    	    $row = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND physicalname='$this_file';" );
    	    $data = ( is_array ( $row ) ) ? $row : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $this_file, "url" => $url );
    	    $folder .= $this -> createHTMLFile ( $data, $side );
    	}

    	return $folder;
    } // end readFolders

    private function createHTMLFile ( $file, $side )
    {
    	if ( !SecurityTools::check_read ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
    	    return; // user doesn`t have permission to read this article
    	}
    	$file_title = ( isset ( $file [ "title" ] ) ) ? $file [ "title" ] : $file [ "physicalname" ];
    	$title = ( strlen ( $file_title ) > 28 || ( strlen ( $file_title ) > 14 && stripos ( substr ( $file_title, 0, 12 ), " " ) === false ) ) ? substr ( $file_title, 0, 11 ) ."..." : $file_title;
        $fold = substr ( $file [ "url" ], 1, -1 );

    	$type = substr ( strrchr ( $file_title, "." ), 1 ); // find type of file
    	if ( $type == "php" || $type == "bak" ) return;

        $class = ""; // css class of button
        $action = ""; // javascript action for button
    	
    	switch ( strtolower($type) ) {
    	    case "jpg":
    	    case "gif":
    	    case "png":
    	    case "ico":
    	    case "bmp":
    	    	$class = "imageFile";
    	    	$action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=image&#038;src=$fold/$file_title',800);";
                return '<a href="#" class="cor-button cor-'. $class .'" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'file\',\''. $file [ "url" ] . $file [ "physicalname" ] .'\',\''. $this -> cordrive .'\');return false;" ondblclick="'. $action .'" title="'. $file_title .'"><span>'. $title .'</span></a>';
    	    	break;
    	    case "css":
    	    	$class = "cssFile";
    	    	$action = "ajaxWidthDialogue('". $this -> corsourceeditor .".xml?src=$fold/$file_title',800);";
                return '<a href="#" class="cor-button cor-'. $class .'" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'file\',\''. $file [ "url" ] . $file [ "physicalname" ] .'\',\''. $this -> cordrive .'\');return false;" ondblclick="'. $action .'" title="'. $file_title .'"><span>'. $title .'</span></a>';
    	    	break;
    	    case "html":
    	    	$class = "htmlFile";
    	    	$action = "ajaxWidthDialogue('". $this -> corsourceeditor .".xml?src=$fold/$file_title',800);";
                return '<a href="#" class="cor-button cor-'. $class .'" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'file\',\''. $file [ "url" ] . $file [ "physicalname" ] .'\',\''. $this -> cordrive .'\');return false;" ondblclick="'. $action .'" title="'. $file_title .'"><span>'. $title .'</span></a>';
    	    	break;
            case "hs":
            case "java":
                $type="source";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "doc":
            case "docx":
            case "odt":
            case "rtf":
                $type="document";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "xls":
            case "xlsx":
            case "ods":
                $type="document";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "exe":
                $type="executable";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "rar":
                $type="rar";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "zip":
                $type="zip";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "tar":
            case "gz":
            case "gz2":
                $type="tar";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "pdf":
                $type="pdf";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";;
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "mp3":
            case "wma":
            case "wav":
            case "ogg":
            case "aac":
                $type="sound";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "avi":
            case "mpg":
            case "wmv":
            case "mpeg":
                $type="video";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',650);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
            case "mov":
                $type="applevideo";
                $action = "ajaxWidthDialogue('". $this -> cordrive .".xml?action=downloadshow&#038;src=$fold/$file_title',56500);";
                return $this->createNewStyleButton ($file [ "physicalname" ],$file [ "url" ] . $file [ "physicalname" ],$action,$type,$title);
                break;
    	    default:
    	    	$class = "unknownFile";
                return '<a href="#" class="cor-button cor-'. $class .'" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'file\',\''. $file [ "url" ] . $file [ "physicalname" ] .'\',\''. $this -> cordrive .'\');return false;" ondblclick="'. $action .'" title="'. $file_title .'"><span>'. $title .'</span></a>';
    	}
    } // end createHTMLFile

    private function createNewStyleButton ($name,$file,$action,$type,$title) {
        return '<a href="#" onmouseover="$(this).fadeTo(1, 0.7);" onmouseout="$(this).fadeTo(1, 1);" style="text-decoration:none;" class="cor-newstylebutton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'file\',\''. $file .'\',\''. $this -> cordrive .'\');return false;" ondblclick="'. $action .'" title="'. $name .'">
                <img src="styles/fileicons/'.$type.'.jpg" /><span>'. $title .'</span></a>';
    }

    private function createHTMLDir ( $folder, $side )
    {
        if ( !SecurityTools::check_read ( $folder [ "access" ], $folder [ "author" ], $folder [ "groupid" ] ) ) {
    	    return; // user doesn`t have permission to read this article
    	}
    	$folder_title = ( isset ( $folder [ "title" ] ) ) ? $folder [ "title" ] : $folder [ "physicalname" ];
    	$title = ( strlen ( $folder_title ) > 28 || ( strlen ( $folder_title ) > 14 && stripos ( substr ( $folder_title, 0, 12 ), " " ) === false ) ) ? substr ( $folder_title, 0, 11 ) ."..." : $folder_title;
        return '<a href="#" class="cor-button cor-dirButton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'directory\',\''. $folder [ "url" ] . $folder [ "physicalname" ] ."/" .'\',\''. $this -> cordrive .'\');return false;" title="'. $folder_title .'" ondblclick="directoryContent.getDirectoryContent(\''. Tools::getPage () .'.xml?contentdir='. $folder [ "url" ] . $folder [ "physicalname" ] ."/" .'&#038;side='. $side. '\',\''. $side .'\',\''. $folder [ "url" ] . $folder [ "physicalname" ] ."/" .'\');"><span>'. $title .'</span></a>';

    } // end createHTMLDir

    private function uploadFile ()
    {
    	if ( !isset ( $_POST [ "parent" ] ) || $_POST [ "parent" ] == "/" ) {
            $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Nelze nahrávat soubory do kořenového adresáře!" ) .'</strong></p>';
            return;
        }

        $src = addslashes ( substr ( $_POST [ "parent" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $urlphysicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $urlphysicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $urlphysicalname = ( substr ( $urlphysicalname, -1 ) == "/" ) ? substr ( $urlphysicalname, 0, -1 ) : $urlphysicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$urlphysicalname';" );

        // if folder isn`t defined in database, we don`t allow you to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

    	$files = $_FILES [ "file" ];
    	$physicalname = htmlspecialchars ( $files [ "name" ] );
        $bad_chars = array ( " ", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "ä", "č", "ď", "é", "ě", "í", "ĺ", "ľ", "ň", "ó", "ô", "ŕ", "ř", "š", "ť", "ú", "ů", "ý", "ž" );
        $asci_chars = array ( "-", "", "", "", "", "", "", "", "", "a", "a", "c", "d", "e", "e", "i", "l", "l", "n", "o", "o", "r", "r", "s", "t", "u", "u", "y", "z" );
        $physicalname = urlencode ( str_replace ( $bad_chars, $asci_chars, $physicalname ) );
    	$access = htmlspecialchars ( $_POST [ "access" ] );
        $group = (int) $_POST [ "usergroup" ];

        if ( $physicalname == "root" ) {
            $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong></p>';
            return;
        }

        // nobody can upload php files ///////////////////////////////////////////////
        if ( !$this -> checkFileType ( $physicalname ) ) {
            $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Albireo rozpoznalo nahrávaný soubor jako potenciální PHP skript, který by mohl poškodit systém. Náhrání tohoto souboru nebude povoleno" ) .'!</strong></p>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        if ( Database::connection () -> getResult ( "SELECT `physicalname` FROM `drivefilesv2` WHERE `url`='/$src' AND `physicalname`='$physicalname';" ) ) {
            $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Soubor tohoto jména už existuje!" ) .'!</strong></p>';
            return;
        }

        $path = $src;

    	if ( $physicalname == "" ) {
    	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Soubor nemá název!" ) .'</strong></p>';
    	    return;
    	}

        $type = substr ( strrchr ( $physicalname, "." ), 1 );

        if ( @move_uploaded_file ( $files [ "tmp_name" ],  $path . $physicalname ) ) {
            if ( Database::connection () -> query ( "INSERT INTO `drivefilesv2` VALUES ( '/$src','$physicalname', ". User::session () -> getId () .", '$group', '$access' );" ) ) {
                $this -> page [ "text" ] .= '
	    	    <p class="success" id="upload">'. $path . $physicalname .' ('. $files [ "type" ] .' - '. (int) ( $files[ "size" ] / 1024 ) .'kB) - '. _( "Soubor byl úspěšně nahrán na server." ) .'</p>';
            } else {
                $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Soubor byl nahrán na server, ale nepodařilo se vytvořit záznam v databázi!" ) .'</strong></p>';
            }
        } else {
            $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se nahrát soubor na server!" ) .'</strong></p>';
            return;
        }

    } // end uploadFile

    private function checkFileType ( $physicalname )
    {
    	$type = substr ( strrchr ( $physicalname, "." ), 1 ); // find type of file
    	if ( $type == "" || substr ( $type, 0, 3 ) == "php" || $type == "phtml" ) {
    	    return false;
    	} else {
    	    return true;
    	}
    } // end checkFileType

}

$DriveContents = new DriveContents ();
$page = $DriveContents -> page;
?>