<?php
/* **************************************************************************** *

 * cor-articles.php								*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page for managing articles of Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class Drive {

    public $page = array ( "text" => "" );

    public function __construct ()
    {
    	
    	switch ( $_REQUEST [ "action" ] ) {
    	    case "createThisFile":
    	    	$this -> createThisFile ();
    	    	break;
    	    case "createfile":
    	    	$this -> createFile ();
    	    	break;
    	    case "newfolder":
    	    	$this -> folderEditor ();
    	    	break;
    	    case "createfolder":
    	    	$this -> createFolder ();
    	    	break;
    	    case "image":
    	    	$this -> showImage ();
    	    	break;
    	    case "upload":
    	    	$this -> uploadForm ();
    	    	break;
            case "gearsuploadform":
    	    	$this -> gearsUploadForm ();
    	    	break;
            case "gearsupload":
                $this -> gearsUpload ();
                break;
    	    case "copy":
                $this -> copyIt ();
    	    	break;
    	    case "move":
    	    	$this -> moveIt ();
    	    	break;
    	    case "delete1":
    	    	$this -> reallyDelete ();
    	    	break;
    	    case "delete2":
    	    	$this -> deleteIt ();
    	    	break;
            case "downloadshow":
                $this -> downloadshow();
                break;
    	    case "editfile":
    	    case "showdirinfo":
    	    	$this -> editFile ();
    	    	break;
    	}
    } // end __construct

    private function createThisFile ()
    {
    	$this -> page [ "title" ] = _( "Nová složka" );

        if ( empty  ( $_POST [ "parent" ] ) || $_POST [ "parent" ] == "/" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové složky v kořenovém adresáři!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $src = addslashes ( substr ( $_POST [ "parent" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND`physicalname`='$physicalname';" );

        if ( !( ( $physicalname == "bodies" ||
             $physicalname == "headers" ) && $url == "/xhtml/" ) &&
             !( $physicalname == "styles" && $url == "/" ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubory je možné vytvářet jen ve složkách xhtml/headers, xhtml/bodies a styles." ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        if ( $physicalname == "bodies" ) {
            $type = "html";
            $Filetext =
' <body>
     <!-- '. _( "Zde vložte XHTML kód pro šablonu webové stránky. Rozšiřující XML značky naleznete na www.albireo.name. Konečnou šablonu pak připojte ke složce ve správě obsahu webu." ) .' --!>
 </body>';
        } elseif ( $physicalname == "headers" ) {
            $type = "html";
            $Filetext =
' <head>
     <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=UTF-8" />
     <meta http-equiv="Content-Language" content="'. _( "cs" ) .'" />
     <meta http-equiv="Cache-Control" content="no-cache" />
     <meta http-equiv="content-script-type" content="text/JavaScript" />
     <meta http-equiv="content-style-type" content="text/css" />
     <meta name="copyright" content="copyright '. date ( "Y" ) .' '. _( "Vaše firma" ) .'" />
     <meta name="author" content="all: '. _( "Autor; autor@e-mail.tld" ) .'" />
     <title>'. _( "Titulek stránky" ) .' - <extension><pageinterface variable="title" /></extension></title>
     <link rel="stylesheet" type="text/css" href="styles/'. _( "vas-soubor-se-stylem" ) .'.css" charset="UTF-8" media="screen" />
     <!--[if IE ]>
  	 <link rel="stylesheet" type="text/css" href="styles/'. _( "vas-soubor-se-stylem-pro-msie" ) .'.css" charset="UTF-8" media="screen" />
     <![endif]-->
     <link rel="icon" href="favicon.ico" type="image/x-icon" />
     <link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
 </head>';
        } else {
            $type = "css";
            $Filetext = '/* '. _( "Zde vytvořte kód pro externí CSS styl. Ten nezapomeňte do jedné z šablon v xhtml/headers připojit tagem:" ) .' <link rel="stylesheet" type="text/css" href="styles/'. _( "vas-soubor-se-stylem" ) .'.css" charset="UTF-8" media="screen" /> */';
        }

        // if folder isn`t defined in database, we don`t allow to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $name = htmlspecialchars ( $_POST [ "title" ] );
        $bad_chars = array ( " ", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "ä", "č", "ď", "é", "ě", "í", "ĺ", "ľ", "ň", "ó", "ô", "ŕ", "ř", "š", "ť", "ú", "ů", "ý", "ž" );
        $asci_chars = array ( "-", "", "", "", "", "", "", "", "", "a", "a", "c", "d", "e", "e", "i", "l", "l", "n", "o", "o", "r", "r", "s", "t", "u", "u", "y", "z" );
        $name = urlencode ( str_replace ( $bad_chars, $asci_chars, $name ) );
        $access = htmlspecialchars ( $_POST [ "access" ] );
        $group = (int) $_POST [ "usergroup" ];

        if ( $name == "root" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        if ( $text = $this -> check_duplicity ( $name, "/". $src ) ) { // there is some duplicity in database
    	    $this -> page [ "text" ] .= $text;
    	    return;
    	}

        $path = $src.$name;

        if ( @file_put_contents ( $path .'.'. $type, $Filetext ) ) {
            if ( Database::connection () -> query ( "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ( '/$src', '$name.$type', ". User::session () -> getId () .", '$group', '$access' );" ) ) {
                $this -> page [ "text" ] = '<p>'. $name . _( " - soubor úspěšně vytvořen." ) .'</p>';
            } else {
                $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se vytvořit záznam o souboru v databázi, ten se však na disku již nachází!" ) .'</strong></p>';
            }
        } else {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Albireo nemohlo zapsat soubor na disk" ) .': '. $path .'</strong></p>';
        }
        $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    }  // end createThisFile

    private function createFile ()
    {
    	$this -> page [ "title" ] = _( "Vytvořit soubor" );

        if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "/" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové soubory v kořenovém adresáři!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $src = addslashes ( substr ( $_GET [ "dirid" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND`physicalname`='$physicalname';" );

        if ( !( ( $physicalname == "bodies" ||
             $physicalname == "headers" ) && $url == "/xhtml/" ) &&
             !( $physicalname == "styles" && $url == "/" ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubory je možné vytvářet jen ve složkách xhtml/headers, xhtml/bodies a styles." ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        if ( $physicalname == "bodies"  || $physicalname == "headers" ) {
            $type = "html";
        } else {
            $type = "css";
        }

        // if folder isn`t defined in database, we don`t allow to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $this -> page [ "text" ] = '
        <form action="xml.php?page='. Tools::getPage () .'" id="CreateFileForm" method="post" enctype="application/x-www-form-urlencoded">
            <fieldset>
                <label for="title">'. _( 'Jméno' ) .': </label><input type="text" name="title" maxlength="50" />.'. $type .'<br />
                <label for="access">'. _( 'Přístup' ) .': </label>
            <select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
                    <option value="wwr">'. _( "Veřejný" ) .'</option>
                    <option value="ww0">'. _( "Skupinový" ) .'</option>
                    <option value="wrr" selected="selected">'. _( "Chráněný" ) .'</option>
                    <option value="wr0">'. _( "Soukromý" ) .'</option>
                    <option value="w00">'. _( "Zabezpečený" ) .'</option>
                </select><br />
                <span id="accessInformation" class="floatLeft"><strong>'. _( "Autor a skupina mohou zapisovat a ostatní nemohou nic." ) .'</strong></span><br />
                <label for="usergroup">'. _( 'Skupina' ) .': </label>
                <select name="usergroup">';
        if ( User::session () -> getPrimaryGroup () >= 3 ) {
             $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
             foreach ( $usergroups as $group ) {
            $this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
             }
             if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
        } else {
             $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
             if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
             foreach ( $usergroups as $group ) {
            $this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
             }
        }
        $this -> page [ "text" ] .= '</select><br />
                <input type="hidden" name="parent" value="'. htmlspecialchars ( $_GET [ "dirid" ] ) .'" />
                '. _( "Cesta:" ) . ' <strong>'. $src .'</strong><br />
                <input class="dialoguebutton" type="submit" value="'. _( "Vytvořit" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml?action=createThisFile\',\'CreateFileForm\');return false;" />
            </fieldset>
        </form>';

    } // end createFile

    private function editFile ()
    {

    	$src = !empty  ( $_GET [ "physicalname" ] ) ? htmlspecialchars ( $_GET [ "physicalname" ] ) : ( ( !empty ( $_GET [ "id" ] ) ) ? htmlspecialchars ( $_GET [ "id" ] ) : htmlspecialchars ( $_POST [ "file" ] ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }

    	$this -> page [ "title" ] = _( "Editovat soubor" );

    	// access checking ///////////////////////////////////////////////////////////
        if ( ! ( $file = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor nemá předobraz v databázi" ) .'!</strong></p>';
            return;
        }
        if ( !SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno mazání tohoto souboru" ) .'!</strong></p>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        if ( !empty ( $_POST [ "physicalname" ] ) &&  !empty ( $_POST [ "access" ] ) && !empty ( $_POST [ "usergroup" ] ) && !empty ( $_POST [ "file" ] )&& !empty ( $_POST [ "url" ] ) ) {
            $newphysicalname = htmlspecialchars ( $_POST [ "physicalname" ] );
            $bad_chars = array ( " ", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "ä", "č", "ď", "é", "ě", "í", "ĺ", "ľ", "ň", "ó", "ô", "ŕ", "ř", "š", "ť", "ú", "ů", "ý", "ž" );
            $asci_chars = array ( "-", "", "", "", "", "", "", "", "", "a", "a", "c", "d", "e", "e", "i", "l", "l", "n", "o", "o", "r", "r", "s", "t", "u", "u", "y", "z" );
            $newphysicalname = urlencode ( str_replace ( $bad_chars, $asci_chars, $newphysicalname ) );
            $access = htmlspecialchars ( $_POST [ "access" ] );
            $groupid = (int) $_POST [ "usergroup" ];
            $url = addslashes ( $_POST [ "url" ] );

            if ( $physicalname != $newphysicalname && ( $error = $this -> check_duplicity ( $newphysicalname, $file [ "url" ] ) ) ) {
                $this -> page [ "text" ] .= $error;
                return;
            }
	    
            $fold_from = substr ( $url, 1 );
            $slash = strrpos ( substr ( $url, 0, -1 ), "/" );
            $new_url =  $url . $newphysicalname;

        if ( rename ( $fold_from . $physicalname, $fold_from . $newphysicalname ) ) {
	    	if ( Database::connection () -> query ( "UPDATE `drivefilesv2` SET `physicalname`='$newphysicalname', `access`='$access', `groupid`=$groupid WHERE `url`='$url' AND `physicalname`='$physicalname';" ) &&
                 Database::connection () -> query ( "UPDATE `drivefilesv2` SET `url`=CONCAT('$new_url',SUBSTRING(`url` FROM ".(strlen($url.$physicalname)+1).")) WHERE `URL` LIKE '".$url.$physicalname."%';" )) {
	    	    $this -> page [ "text" ] .= "<p>". _( "Soubor byl úspěšně editován." ) ."</p>";
	    	} else {
	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se editovat soubor" ) .' '. $physicalname .'.</strong></p>';
	    	}
	    } else {
	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se fyzicky editovat soubor" ) .' '. $physicalname .'.</strong></p>';
	    }
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$this -> page [ "text" ] = '
	<form action="'. Tools::getPage () .'.xml" id="EditorForm" method="post" enctype="application/x-www-form-urlencoded">
	    <fieldset>
	    	<label for="title">'. _( 'Jméno' ) .': </label><input type="text" name="physicalname" maxlength="50" value="'. $file [ "physicalname" ] .'" /><br />
	    	<label for="access">'. _( 'Přístup' ) .': </label>
	    	<select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
	    	    <option value="wwr"'. ( ( $file [ "access" ] == "wwr" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Veřejný" ) .'</option>
	    	    <option value="ww0"'. ( ( $file [ "access" ] == "ww0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Skupinový" ) .'</option>
	    	    <option value="wrr"'. ( ( $file [ "access" ] == "wrr" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Chráněný" ) .'</option>
	    	    <option value="wr0"'. ( ( $file [ "access" ] == "wr0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Soukromý" ) .'</option>
	    	    <option value="w00"'. ( ( $file [ "access" ] == "w00" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Zabezpečený" ) .'</option>
	    	</select><br />';

	$accessInfo = "";
	switch ( $file [ "access" ] ) {
	    case 'ww0':
	    	$accessInfo = _( "Autor a skupina mohou zapisovat a ostatní nemohou nic." );
	    	break;
	    case 'wrr':
	    	$accessInfo = _( "Autor může zapisovat a skupina a ostatní mohou číst." );
	    	break;
	    case 'wr0':
	    	$accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní nemohou nic." );
	    	break;
	    case 'w00':
	    	$accessInfo = _( "Autor může zapisovat a skupina a ostatní nemohou nic." );
	    	break;
	    default:
	    	$accessInfo = _( "Autor a skupina mohou zapisovat a ostatní mohou číst." );
	        
	}
	$this -> page [ "text" ] .= '<span id="accessInformation" class="floatLeft"><strong>'. $accessInfo .'</strong></span><br />
	    	<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';
	if ( User::session () -> getPrimaryGroup () >= 3 ) {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
	     }
	     if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
	} else {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
	     if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
	     }
	}
	$this -> page [ "text" ] .= '</select><br />';
	if ( is_array ( $file ) ) {
	    $this -> page [ "text" ] .= '<input type="hidden" name="file" value="'.  substr( $file [ "url" ], 1 ) . $file [ "physicalname" ] .'" />
        <input type="hidden" name="url" value="'. $file [ "url" ] .'" />';
	}
	$this -> page [ "text" ] .= _( "Cesta:" ) . ' <strong>'. substr( $file [ "url" ], 1 ) .'</strong><br />
	    	<input class="dialoguebutton" type="submit" value="'. _( "Editovat" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml?action=editfile\',\'EditorForm\');return false;" />
	    </fieldset>
	</form>';

    } // end editFile

    private function deleteIt ()
    {
    	$this -> page [ "title" ] = _( "Smazat" );

        $successfuldelete = "<p>". _( "Smazání proběhlo úspěšně." ) ."</p>";
        $unsuccessfuldelete = '<p><strong class="warning">'. _( "Smazání se nezdařilo." ) ."</strong>"."</p>";

        $src = ( !empty  ( $_GET [ "file" ] ) ) ? htmlspecialchars ( $_GET [ "file" ] ) : htmlspecialchars ( $_GET [ "directory" ] );
        $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
        $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
        $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );

        // access checking ///////////////////////////////////////////////////////////
        if ( ! ( $file = Database::connection () -> fetch_assoc ( "SELECT `author`, `groupid`, `access` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor nemá předobraz v databázi" ) .'!</strong></p>';
            return;
        }
        if ( !SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno mazání tohoto souboru" ) .'!</strong></p>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $fold_from = substr ( $url, 1 );;

        if ( !empty  ( $_GET [ "file" ] ) ) {
            if ( unlink ( $fold_from . $physicalname ) ) {
                if ( Database::connection () -> query ( "DELETE FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) ) {
                    $this -> page [ "text" ] .= $successfuldelete;
                } else {
                    $this -> page [ "text" ] .= $unsuccessfuldelete;
                }
            } else {
                $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se smazat fyzický soubor" ) .' '. $physicalname .'!</strong></p>';
            }
        } elseif ( !empty  ( $_GET [ "directory" ] ) ) {
            if ( $_GET [ $type ] == "styles" || $_GET [ $type ] == "xhtml" || $_GET [ $type ] == "images" ) {
                $this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Nemůžete mazat tyto složky!" ) ."</strong></p>";
                return;
            }
            $files_inside = Database::connection () -> getResult ( "SELECT COUNT(*) FROM `drivefilesv2` WHERE `url`='/$src';" );
            if ( $files_inside > 0 ) {
                $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Složka není prázdná, nelze ji proto smazat" ) .'!</strong></p>';
                return;
            }

            if ( rmdir ( $fold_from . $physicalname ) ) {
                if ( Database::connection () -> query ( "DELETE FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) ) {
                    $this -> page [ "text" ] .= $successfuldelete;
                } else {
                    $this -> page [ "text" ] .= $unsuccessfuldelete;
                }
            } else {
                $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se smazat fyzickou složku" ) .' '. $physicalname .'!</strong></p>';
            }
        }

        $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end deleteIt

    private function reallyDelete ()
    {
    	$this -> page [ "title" ] = _( "Smazat" );
    	$type = ( isset ( $_GET [ "directory" ] ) ) ? "directory" : "file";
        $src = ( !empty  ( $_GET [ "file" ] ) ) ? htmlspecialchars ( $_GET [ "file" ] ) : htmlspecialchars ( $_GET [ "directory" ] );
        $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
        $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
        $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
        if ( $url == "/" ) {
            $this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Nemůžete mazat tyto složky!" ) ."</strong></p>";
            return;
        }
    	$this -> page [ "text" ] .= "<p>". _( "Opravdu si přejete tento objekt vymazat?" ) ."</p>";

    	if ( Database::connection () -> getResult ( "SELECT `groupid` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) == 1 ) {
    	    $this -> page [ "text" ] .= "<div><strong class=\"warning\">". _( "Buďte opatrní, mažete soubor patřící skupině administrátorů" ) ."!</strong></div>";
    	}
    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="changeWidthDialogueByGET(\''. Tools::getPage () .'.xml?action=delete2&#038;'. $type .'='. $_GET [ $type ] .'\',550);directoryContent.destroyArticleActions();" value="'. _( "ano" ) .'" /> <input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "ne" ) .'" />';
    } // end reallyDelete

    private function moveFile ( $target_dir, $file )
    {
        $src = addslashes ( substr ( $file, 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }
        $target_directory = addslashes ( substr ( $target_dir, 1 ) );
        $target_physicalname = substr ( strrchr ( substr ( $target_directory, 0, -1 ), "/" ), 1 ).substr($target_directory,-1);
        $target_physicalname = ( substr ( $target_physicalname, -1 ) == "/" ) ? substr ( $target_physicalname, 0, -1 ) : $target_physicalname;
        $target_slash = strrpos ( substr ( $target_directory, 0, -1 ), "/" );
        $target_url = ( substr ( $target_directory, 0, 1 ) == "/" ) ? substr ( $target_directory , 0, $slash+1 ) : "/".substr ( $target_directory , 0, $target_slash+1 );

    	if ( $target_dir == "/" ) {
            $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze provádět přesun do kořenové složky." ) .'</strong></p>';
            return;
        }
        if ( $physicalname == "styles" || $physicalname == "xhtml" || $physicalname == "images" ) {
            $this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Nemůžete přesouvat tyto složky!" ) ."</strong></p>";
            return;
        }
        // access checking ///////////////////////////////////////////////////////////
        $access_dir = Database::connection () -> fetch_assoc ( "SELECT `author`, `groupid`, `access` FROM `drivefilesv2` WHERE `url`='$target_url' AND `physicalname`='$target_physicalname';" );
        if ( !SecurityTools::check_write ( $access_dir [ "access" ], $access_dir [ "author" ], $access_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            return;
        }
        $access_object = Database::connection () -> fetch_assoc ( "SELECT `author`, `groupid`, `access` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" );
        if ( !SecurityTools::check_write ( $access_object [ "access" ], $access_object [ "author" ], $access_object [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno přesunování tohoto souboru" ) .'!</strong></p>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $fold_from = $src;
    	$fold_to = $target_directory;

        if ( $text = $this -> check_duplicity ( $physicalname, "/". $target_directory ) ) { // there is some duplicity in database
            $this -> page [ "text" ] .= $text;
            return;
        }
//$this -> page [ "text" ] .="UPDATE `drivefilesv2` SET `url`=CONCAT('/$target_directory$physicalname',SUBSTRING(`url` FROM ".(strlen($url.$physicalname)+2).")) WHERE `URL` LIKE '".$url.$physicalname."%';";return;
        if ( rename ( $fold_from,  $fold_to . $physicalname ) ) {
            if ( Database::connection () -> query ( "UPDATE `drivefilesv2` SET `url`='/$target_directory' WHERE `url`='$url' AND `physicalname`='$physicalname';" ) &&
                 Database::connection () -> query ( "UPDATE `drivefilesv2` SET `url`=CONCAT('/$target_directory$physicalname',SUBSTRING(`url` FROM ".(strlen($url.$physicalname)+1).")) WHERE `URL` LIKE '".$url.$physicalname."%';" ) ) {
                $this -> page [ "text" ] .= "<p>". _( "Přesun proběhl úspěšně." ) ."</p>";
            } else {
                $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Přesun se nezdařil." ) ."</strong>"."</p>";
            }
        } else {
            $this -> page [ "text" ] .= '<p><strong class="warning">'.$fold_from." * ".$fold_to . $physicalname. " - ". _( "Nepodařilo se přesunout fyzický soubor." ) ."</strong>"."</p>";
        }
    }

    private function moveIt ()
    {
    	$this -> page [ "title" ] = _( "Přesun" );

        $successfulmove = "<p>". _( "Přesun proběhl úspěšně." ) ."</p>";
        $unsuccessfulmove = '<p><strong class="warning">'. _( "Přesun se nezdařil." ) ."</strong>"."</p>";

        if ( $_GET [ "leftdir" ] == $_GET [ "rightdir" ] ) {
            $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze přesouvat ve stejných složkách." ) .'</strong></p>';
            return;
        }

        // moves file ////////////////////////////////////////////////////////////////
        if ( ( isset ( $_GET [ "file" ] ) || isset ( $_GET [ "directory" ] ) ) && isset ( $_GET [ "leftdir" ], $_GET [ "rightdir" ] ) ) {
            $what = ( isset ( $_GET [ "file" ] ) ) ? htmlspecialchars ( $_GET [ "file" ] ) : htmlspecialchars ( $_GET [ "directory" ] );
            $src = addslashes ( substr ( $what, 1 ) );
            if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
                $url = "/";
                $physicalname = substr ( $src, 0, -1 );
            } else {
                $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
                $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
                $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
                $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
            }

            if ( $file = Database::connection () -> getResult ( "SELECT `url` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) ) {
                // move article from left directory to right directory ///////////////////////
                if ( $file == $_GET [ "leftdir" ] ) {
                    $this -> moveFile ( $_GET [ "rightdir" ], $what );
                //////////////////////////////////////////////////////////////////////////////
                // move article from right directory to left directory ///////////////////////
                } elseif ( $file == $_GET [ "rightdir" ] ) {
                    $this -> moveFile ( $_GET [ "leftdir" ], $what );
                //////////////////////////////////////////////////////////////////////////////
                } else {
                    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se určit složky pro přesun." ) .'</strong></p>';
                }
            } else {
                $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se načíst údaje z databáze." )."SELECT `url` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" .'</strong></p>';
            }
        //////////////////////////////////////////////////////////////////////////////
        }
    	
    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end moveIt

    private function copyFile ( $file, $directory )
    {

        $directory = addslashes ( substr ( $directory, 1 ) );
        $physicalname = substr ( strrchr ( substr ( $directory, 0, -1 ), "/" ), 1 ).substr($directory,-1);
        $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        $slash = strrpos ( substr ( $directory, 0, -1 ), "/" );
        $url = ( substr ( $directory, 0, 1 ) == "/" ) ? substr ( $directory , 0, $slash+1 ) : "/".substr ( $directory , 0, $slash+1 );

        // access checking ///////////////////////////////////////////////////////////
        $row = Database::connection () -> fetch_assoc ( "SELECT `author`, `groupid`, `access` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" );
    	$parent_dir = ( is_array ( $row ) ) ? $row : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $physicalname );

        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            return;
        }
        if ( !SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno kopírování tohoto souboru" ) .'!</strong></p>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

    	$copy = _( "kopie" );
        $target = $file [ "physicalname" ];

    	if ( $text = $this -> check_duplicity ( $target, "/". $directory ) ) { // there is some duplicity in database
            $target = $copy ."-". $target;
            if ( $text = $this -> check_duplicity ( $target, "/". $directory ) ) { // there is some duplicity in database
                $this -> page [ "text" ] .= $text;
                return;
            }
    	}

        $fold_from = substr ( $file [ "url" ], 1 );
    	$fold_to = $directory;

    	if ( copy ( $fold_from . $file [ "physicalname" ],  $fold_to . $target ) &&
    	     file_exists ( $fold_to ."/". $file [ "physicalname" ] ) ) {
    	    if ( Database::connection () -> query ( "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ( '/$directory','". $target ."', ". User::session () -> getId () .", '". $file [ "groupid" ] ."', '". $file [ "access" ] ."' );" ) ) {
                $this -> page [ "text" ] .= "<p>". $file [ "physicalname" ] ." - ". _( "Kopírování souboru proběhlo úspěšně." ) ."</p>";
            } else {
                $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se vytvořit obsah kopie souboru" ) .' '. $file [ "physicalname" ] .'.</strong></p>';
            }
        } else {
            $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se vytvořit fyzickou kopii souboru" ) .' '. $file [ "physicalname" ] .'.</strong></p>';
        }

    } // end copyFile

    private function copyIt ()
    {
    	$this -> page [ "title" ] = _( "Kopírování" );

        $successfulcopy = "<p>". _( "Kopírování proběhlo úspěšně." ) ."</p>";
        $copy = _( "kopie" );

        if ( !empty  ( $_GET [ "file" ] ) && !empty ( $_GET [ "leftdir" ] ) && !empty ( $_GET [ "rightdir" ] ) ) {
            $src = addslashes ( $_GET [ "file" ] );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            if ( $file = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" ) ) { // gets file from database
                // copy file from left window /////////////////////////////////////////////////
                if ( $file [ "url" ] == $_GET [ "leftdir" ] ) { // it`s file from left window
                    if ( $_GET [ "rightdir" ] == "/" ) {
                        $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze provádět kopírování do kořenové složky." ) .'</strong></p>';
                        return;
                    }
                    $this -> copyFile ( $file, $_GET [ "rightdir" ] );
                //////////////////////////////////////////////////////////////////////////////
                // copy file from right window ///////////////////////////////////////////////
                } elseif ( $file [ "url" ] == $_GET [ "rightdir" ] ) { // it`s file from right window
                    if ( $_GET [ "leftdir" ] == "/" ) {
                        $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze provádět kopírování do kořenové složky." ) .'</strong></p>';
                        return;
                    }
                    $this -> copyFile ( $file, $_GET [ "leftdir" ] );
                //////////////////////////////////////////////////////////////////////////////
                } else {
                    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se určit složky pro kopírování." ) .'</strong></p>';
                }
            } else {
                $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se načíst soubor. Pravděpodobně jde o soubor bez záznamu v databázi." ) .'</strong></p>';
            }
        }

    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end copyIt

    private function gearsUploadForm ()
    {
        $this -> page [ "title" ] = _( "Nahrát soubory na server" );

        if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "/" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze nahrávat soubory do kořenového adresáře!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $src = addslashes ( substr ( $_GET [ "dirid" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" );

        // if folder isn`t defined in database, we don`t allow to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $this -> page [ "text" ] .= '<table id="GearsUploadeFileList" class="table"></table>';
        $this -> page [ "text" ] .= '<button class="dialoguebutton" id="GearsUploaderSelect" onclick="uploader.selectFiles();return false;">'. _( "Vyber" ) .'</button>';
        $this -> page [ "text" ] .= '<button class="dialoguebutton" id="GearsUploaderUpload" onclick="uploader.uploadFiles(\''. htmlspecialchars($_GET["dirid"]) .'\');return false;" disabled="disabled">'. _( "Nahraj" ) .'</button>';
        $this -> page [ "text" ] .= '<p><strong>'. _( "Cíl:" ) .'</strong> '. $src .'<br />'
        . _( "Povolen hromadný upload - můžete vybrat několik souborů zároveň." ) .'</p>';
    } // end gearsUploadForm

    private function gearsUpload ()
    {
        $fullpath = 'temporary/';
        if ( !isset ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "/" ) {
            $this -> page [ "text" ] .= '<strong class="warning">'. _( "Nelze nahrávat soubory do kořenového adresáře!" ) .'</strong>';
            return;
        }

        $src = addslashes ( substr ( $_GET [ "dirid" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $urlphysicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $urlphysicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $urlphysicalname = ( substr ( $urlphysicalname, -1 ) == "/" ) ? substr ( $urlphysicalname, 0, -1 ) : $urlphysicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$urlphysicalname';" );

        // if folder isn`t defined in database, we don`t allow you to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] .= '<strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong>';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] .= '<strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////
        preg_match('@^attachment; filename="([^"]+)"@',$_SERVER['HTTP_CONTENT_DISPOSITION'],$filename);
        preg_match('@^bytes ([^-]+)-([^/]+)/(.*)@', $_SERVER['HTTP_CONTENT_RANGE'], $bytes);

        $bad_chars = array ( " ", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "ä", "č", "ď", "é", "ě", "í", "ĺ", "ľ", "ň", "ó", "ô", "ŕ", "ř", "š", "ť", "ú", "ů", "ý", "ž" );
        $asci_chars = array ( "-", "", "", "", "", "", "", "", "", "a", "a", "c", "d", "e", "e", "i", "l", "l", "n", "o", "o", "r", "r", "s", "t", "u", "u", "y", "z" );
        $filename[1] = urlencode ( str_replace ( $bad_chars, $asci_chars, $filename[1] ) );

        if ( $filename[1] == "root" ) {
            $this -> page [ "text" ] .= '<strong class="warning">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong>';
            return;
        }

        // nobody can upload php files ///////////////////////////////////////////////
        if ( !$this -> checkFileType ( $filename[1] ) ) {
            $this -> page [ "text" ] .= '<strong class="warning">'. _( "Albireo rozpoznalo nahrávaný soubor jako potenciální PHP skript, který by mohl poškodit systém. Náhrání tohoto souboru nebude povoleno" ) .'!</strong>';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        if ( Database::connection () -> getResult ( "SELECT `physicalname` FROM `drivefilesv2` WHERE `url`='/$src' AND `physicalname`='$filename[1]';" ) ) {
            $this -> page [ "text" ] .= '<strong class="warning">'. _( "Soubor tohoto jména už existuje!" ) .'!</strong>';
            return;
        }

        if (!file_exists($fullpath.'fileparts.txt')) {
            file_put_contents($fullpath.'fileparts.txt','');
        }
        $fp = fopen($fullpath.'/'.$filename[1], 'a');
        fseek($fp, $bytes[1]); // seek to 'start' of partial file
        $fp1 = fopen('php://input','r'); // open the input stream
        while (!feof($fp1)) { // loop through in 8kb "bites"
            fwrite($fp, fread($fp1, 8192));
        }
        fclose($fp1); // close stream
        fclose($fp); // close file

        if (($bytes[1] == 0 && ($bytes[2] + 1) == $bytes[3]) || ($bytes[2] + 1) == $bytes[3]) {
            // we are finishing uploading a partial file OR we have just been sent the complete file

            $curname = $fullpath.'/'.$filename[1];

            $path = $src;
            
            if ( rename ( $curname, $path.$filename[1] ) ){
                if ( Database::connection () -> query ( "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ( '/$src','".$filename[1]."', ". User::session () -> getId () .", '".User::session () ->getPrimaryGroup()."', 'ww0' );" ) ) {
                    $this -> page [ "text" ] .= '<strong class="success">'. _( "Nahráno" ) .'</strong>';
                } else {
                    $this -> page [ "text" ] .= '<strong class="warning">'. _( "Soubor byl nahrán na server, ale nepodařilo se vytvořit záznam v databázi!" ) .'</strong>';
                }
                
            }else{
                $this -> page [ "text" ] .= '<strong class="warning">Přesun souboru do cílové složky selhal</strong>';
            }

        }else{ // file not completed yet

            $fileparts = explode("\n",file_get_contents($fullpath.'fileparts.txt'));
            $found = -1;
            foreach($fileparts as $l => $d) {
                $xd = explode('[=]',$d);
                if ($xd[2] == $filename[1]) {
                    $found = $l;
                }
            }
            if ($found == -1) {
                $fileparts[] = $bytes[2].'[=]'.$bytes[3].'[=]'.$filename[1];
            }elseif (($bytes[2] + 1) == $bytes[3]) {
                unset($fileparts[$found]);
            }else{
                $fileparts[$found] = $bytes[2].'[=]'.$bytes[3].'[=]'.$filename[1];
            }
            file_put_contents($fullpath.'fileparts.txt',implode("\n",$fileparts));
        }
    } // end gearsUploadForm

    private function uploadForm ()
    {

        $this -> page [ "title" ] = _( "Nahrát soubory na server" );

        if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "/" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze nahrávat soubory do kořenového adresáře!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        
        $src = addslashes ( substr ( $_GET [ "dirid" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" );

        // if folder isn`t defined in database, we don`t allow to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) ."SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';".'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $this -> page [ "text" ] = '
        <form action="'. Localization::session () -> getFile ( "cor-drive-contents") .'" method="post" enctype="multipart/form-data">
            <fieldset>
            <label for="file">'. _( 'Soubor' ) .': </label><input type="file" name="file" /><br />
	    	<label for="access">'. _( 'Přístup' ) .': </label>
            <select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
	    	    <option value="wwr">'. _( "Veřejný" ) .'</option>
	    	    <option value="ww0">'. _( "Skupinový" ) .'</option>
	    	    <option value="wrr" selected="selected">'. _( "Chráněný" ) .'</option>
	    	    <option value="wr0">'. _( "Soukromý" ) .'</option>
	    	    <option value="w00">'. _( "Zabezpečený" ) .'</option>
	    	</select><br />
	    	<span id="accessInformation" class="floatLeft"><strong>'. _( "Autor a skupina mohou zapisovat a ostatní nemohou nic." ) .'</strong></span><br />
	    	<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';
        if ( User::session () -> getPrimaryGroup () >= 3 ) {
            $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
            foreach ( $usergroups as $group ) {
                $this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
            }
            if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
        } else {
            $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
            if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
            foreach ( $usergroups as $group ) {
                $this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
            }
        }
        $this -> page [ "text" ] .= '</select><br />
                <input type="hidden" name="parent" value="'. htmlspecialchars ( $_GET [ "dirid" ] ) .'" />
                '. _( "Cesta:" ) . ' <strong>'. $src .'</strong><br />
                <input class="dialoguebutton" type="submit" value="'. _( "Nahrát na server" ) .'" />
            </fieldset>
        </form>
        <p><a href="#" onclick="verifyGoogleGears(true);changeWidthDialogueByGET (\''. Tools::getPage() .'.xml?action=gearsuploadform&#038;dirid='. (int) $_GET [ "dirid" ] .'\',550);return false;">'. _( "Nahrát více souborů zároveň" ) .'</a></p>';
    }

    private function downloadshow()
    {
        $src = htmlspecialchars ( $_GET [ "src" ] );
    	$physicalname = substr ( strrchr ( $src, "/" ), 1 );
        $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
        $url = "/".substr ( $src , 0, $slash+1 );
        $this -> page [ "title" ] = _( "Soubor" ) ." ". $physicalname;

        if ( !file_exists ( $src ) ) {
    	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Požadovaný soubor se na disku nenachází" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $file = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" );
        if (!is_array($file)) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Požadovaný soubor nemá předobraz v databázi" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_read ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno zobrazit tento soubor!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $can_write = SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] );
        if ( $can_write ) {
            $this -> page [ "text" ] .= '<dir class="floatRight">
                <a href="#" class="cor-button-small cor-articleEdit" onclick="changeWidthDialogueByGET(\''. Tools::getPage () .'.xml?action=editfile&#038;physicalname='. $src .'\',550);return false;"><span>'. _( 'editovat' ) .'</span></a>
                </dir>
                <strong>'. _( "Cesta" ) .':</strong> '. $src;
        }
    	$this -> page [ "text" ] .= '<ul class="floatLeft">
            <li><strong>'. _( 'Autor' ) .':</strong> '. Database::connection () -> getResult ( "SELECT nick FROM users WHERE id=". $file [ "author" ] .";" ) .'</li>
            <li><strong>'. _( 'Skupina' ) .':</strong> '. Database::connection () -> getResult ( "SELECT usergroup FROM usergroups WHERE id=". $file [ "groupid" ] .";" ) .'</li>
            <li><strong>'. _( "Přístupová práva" ) .':</strong> '. $file [ "access" ] .'</li>
            <li><strong>'. _( "Velikost" ) .':</strong> <span title="'. filesize ( $src ) .' B">'. (int) ( filesize ( $src ) / 1024 ) .' kB</span></li>
            </ul>';

        if ( $can_write ) {
            $this -> page [ "text" ] .= '<ul class="floatLeft">
                <li><strong>'. _( "Poslední modifikace" ) .':</strong><br />'. date ( "j.n.Y H:i:s", filemtime ( $src ) ) .'</li>
                <li><strong>'. _( "Poslední přístup" ) .':</strong><br />'. date ( "j.n.Y H:i:s", fileatime ( $src ) ) .'</li>
                </ul>';
        }

    	$this -> page [ "text" ] .= '<hr class="cleaner" />';
        if (strlen($_GET["src"])<256) {
            if( Database::connection () -> query ( "DELETE FROM downloadable WHERE url LIKE '%$physicalname';" ) &&
                Database::connection () -> query ( "INSERT INTO downloadable (url,author,groupid,access) VALUES ('". addslashes($_GET["src"]) ."', ". $file["author"] .", ".$file["groupid"].", '".$file["access"]."');" )){
                $this -> page [ "text" ] .= '<input type="button" class="dialoguebutton" onclick="window.open(\''.Localization::session () -> getFile ( "cor-download" ) .'?file='. htmlspecialchars($_GET["src"]) .'\');" value="'. _( "Stáhnout" ) .'" />';
            }
        } else {
            $this -> page [ "text" ] .= '<p><strong class="warning">'._("Soubor nemůže být stažen, protože přístupová URL je moc dlouhá.").'</strong></p><hr class="cleaner" />';
        }
        $this -> page [ "text" ] .= '<input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end downloadshow

    private function showImage ()
    {
    	$this -> page [ "title" ] = _( "Obrázek" );
    	$src = htmlspecialchars ( $_GET [ "src" ] );
    	$physicalname = substr ( strrchr ( $src, "/" ), 1 );
        $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
        $url = "/".substr ( $src , 0, $slash+1 );

    	if ( !file_exists ( $src ) ) {
    	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Požadovaný soubor se na disku nenachází" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $file = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$physicalname';" );
    	$file = ( is_array ( $file ) ) ? $file : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $physicalname, "url" => $url );

    	$this -> page [ "text" ] .= '<div style="margin:0px auto;max-width:700px;max-height:400px;overflow:auto;"><img src="'. $src .'" alt="image '. $src .'" style="overflow:auto;" /></div>';
    	$this -> page [ "text" ] .= '<dir class="floatRight">
        <a href="#" class="cor-button-small cor-articleEdit" onclick="changeDialogueByGET(\''. Tools::getPage () .'.xml?action=editfile&#038;physicalname='. $src .'\');return false;"><span>'. _( 'editovat' ) .'</span></a>
        </dir>';
    	$this -> page [ "text" ] .= '<ul class="floatLeft">
    	<li><strong>'. _( "Cesta" ) .':</strong> '. $src .'</li>
    	<li><strong>'. _( 'Autor' ) .':</strong> '. Database::connection () -> getResult ( "SELECT `nick` FROM `users` WHERE `id`=". $file [ "author" ] .";" ) .'</li>
    	<li><strong>'. _( 'Skupina' ) .':</strong> '. Database::connection () -> getResult ( "SELECT `usergroup` FROM `usergroups` WHERE `id`=". $file [ "groupid" ] .";" ) .'</li>
    	<li><strong>'. _( "Přístupová práva" ) .':</strong> '. $file [ "access" ] .'</li></ul>';

	$this -> page [ "text" ] .= '<ul class="floatLeft">
	<li><strong>'. _( "Velikost" ) .':</strong> <span title="'. filesize ( $src ) .' B">'. (int) ( filesize ( $src ) / 1024 ) .' kB</span></li>
	<li><strong>'. _( "Poslední modifikace" ) .':</strong><br />'. date ( "j.n.Y H:i:s", filemtime ( $src ) ) .'</li>
	<li><strong>'. _( "Poslední přístup" ) .':</strong><br />'. date ( "j.n.Y H:i:s", fileatime ( $src ) ) .'</li>
	</ul>';

    	$this -> page [ "text" ] .= '<hr class="cleaner" /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    	
    }

    private function createFolder ()
    {
    	$this -> page [ "title" ] = _( "Nová složka" );

        if ( empty  ( $_POST [ "parent" ] ) || $_POST [ "parent" ] == "/" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové složky v kořenovém adresáři!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $src = addslashes ( substr ( $_POST [ "parent" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $target_url = "/";
            $target_physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $target_url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $target_physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $target_physicalname = ( substr ( $target_physicalname, -1 ) == "/" ) ? substr ( $target_physicalname, 0, -1 ) : $target_physicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$target_url' AND `physicalname`='$target_physicalname';" );

        // if folder isn`t defined in database, we don`t allow to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $physicalname = htmlspecialchars ( $_POST [ "title" ] );
        $bad_chars = array ( " ", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "ä", "č", "ď", "é", "ě", "í", "ĺ", "ľ", "ň", "ó", "ô", "ŕ", "ř", "š", "ť", "ú", "ů", "ý", "ž" );
        $asci_chars = array ( "-", "", "", "", "", "", "", "", "", "a", "a", "c", "d", "e", "e", "i", "l", "l", "n", "o", "o", "r", "r", "s", "t", "u", "u", "y", "z" );
        $physicalname = urlencode ( str_replace ( $bad_chars, $asci_chars, $physicalname ) );
        $access = htmlspecialchars ( $_POST [ "access" ] );
        $group = (int) $_POST [ "usergroup" ];

        if ( $physicalname == "root" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        if ( $text = $this -> check_duplicity ( $physicalname, "/". $src ) ) { // there is some duplicity in database
            $this -> page [ "text" ] .= $text;
            return;
        }

        $path = $src.$physicalname;

        if ( @mkdir ( $path ) ) {
            if ( Database::connection () -> query ( "INSERT INTO `drivefilesv2` (`url`,`physicalname`,`author`,`groupid`,`access`) VALUES ( '/$src', '$physicalname', ". User::session () -> getId () .", '$group', '$access' );" ) ) {
                $this -> page [ "text" ] = '<p>'. $physicalname . _( " - složka úspěšně vytvořena." ) .'</p>';
            } else {
                $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se vytvořit záznam o složce v databázi, ta se však na disku již nachází!" ) .'</strong></p>';
            }
        } else {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Albireo nemohlo zapsat složku na disk" ) .': '. $path .'</strong></p>';
        }
        $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end createFolder

    private function folderEditor ()
    {

    	$this -> page [ "title" ] = _( "Nová složka" );

        if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "/" ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové složky v kořenovém adresáři!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        $src = addslashes ( substr ( $_GET [ "dirid" ], 1 ) );
        if ( !strrchr ( substr ( $src, 0, -1 ), "/" ) ) {
            $url = "/";
            $physicalname = substr ( $src, 0, -1 );
        } else {
            $slash = strrpos ( substr ( $src, 0, -1 ), "/" );
            $url = ( substr ( $src, 0, 1 ) == "/" ) ? substr ( $src , 0, $slash+1 ) : "/".substr ( $src , 0, $slash+1 );
            $physicalname = substr ( strrchr ( substr ( $src, 0, -1 ), "/" ), 1 ).substr($src,-1);
            $physicalname = ( substr ( $physicalname, -1 ) == "/" ) ? substr ( $physicalname, 0, -1 ) : $physicalname;
        }

        $parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM `drivefilesv2` WHERE `url`='$url' AND`physicalname`='$physicalname';" );

        // if folder isn`t defined in database, we don`t allow to write in
        if ( !is_array ( $parent_dir ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }

        // access checking ///////////////////////////////////////////////////////////
        if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
            $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
            $this -> page [ "text" ] .= '<br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
            return;
        }
        //////////////////////////////////////////////////////////////////////////////

        $this -> page [ "text" ] = '
        <form action="xml.php?page='. Tools::getPage () .'" id="FolderEditorForm" method="post" enctype="application/x-www-form-urlencoded">
            <fieldset>
                <label for="title">'. _( 'Jméno' ) .': </label><input type="text" name="title" maxlength="50" /><br />
                <label for="access">'. _( 'Přístup' ) .': </label>
                <select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
                    <option value="wwr"'. ( ( $folder [ "access" ] == "wwr" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Veřejný" ) .'</option>
                    <option value="ww0"'. ( ( $folder [ "access" ] == "ww0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Skupinový" ) .'</option>
                    <option value="wrr"'. ( ( $folder [ "access" ] == "wrr" ) ? " selected=\"selected\"" : ( $folder [ "access" ] ? "" : " selected=\"selected\"" ) ) .'>'. _( "Chráněný" ) .'</option>
                    <option value="wr0"'. ( ( $folder [ "access" ] == "wr0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Soukromý" ) .'</option>
                    <option value="w00"'. ( ( $folder [ "access" ] == "w00" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Zabezpečený" ) .'</option>
                </select><br />';

        $accessInfo = "";
        switch ( $folder [ "access" ] ) {
            case 'wwr':
                $accessInfo = _( "Autor a skupina mohou zapisovat a ostatní mohou číst." );
                break;
            case 'ww0':
                $accessInfo = _( "Autor a skupina mohou zapisovat a ostatní nemohou nic." );
                break;
            case 'wrr':
                $accessInfo = _( "Autor může zapisovat a skupina a ostatní mohou číst." );
                break;
            case 'wr0':
                $accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní nemohou nic." );
                break;
            case 'w00':
                $accessInfo = _( "Autor může zapisovat a skupina a ostatní nemohou nic." );
                break;
            default:
                $accessInfo = _( "Autor může zapisovat a skupina a ostatní mohou číst." );
	        
        }
        $this -> page [ "text" ] .= '<span id="accessInformation" class="floatLeft"><strong>'. $accessInfo .'</strong></span><br />
        <label for="usergroup">'. _( 'Skupina' ) .': </label>
                <select name="usergroup">';
        if ( User::session () -> getPrimaryGroup () >= 3 ) {
             $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
             foreach ( $usergroups as $group ) {
            $this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
             }
             if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
        } else {
             $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
             if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
             foreach ( $usergroups as $group ) {
            $this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
             }
        }
        $this -> page [ "text" ] .= '</select><br />
                <input type="hidden" name="parent" value="'. htmlspecialchars ( $_GET [ "dirid" ] ) .'" />
                '. _( "Cesta:" ) . ' <strong>'. $src .'</strong><br />
                <input class="dialoguebutton" type="submit" value="'. _( "Vytvořit" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml?action=createfolder\',\'FolderEditorForm\');return false;" />
            </fieldset>
        </form>';

    } // end newFolder

    private function check_duplicity ( $to_check, $url )
    {
    	if ( ( $url_doubler = Database::connection () -> getResult ( "SELECT `url` FROM `drivefilesv2` WHERE `url`='$url' AND `physicalname`='$to_check';" ) ) && $url == $url_doubler ) {
    	    return '<p><strong class="warning">'. _( "Soubor tohoto jména již existuje ve složce" ) .' '. $url_doubler .'.</strong></p>';
        } else {
            return false;
        }
    } // end check_duplicity

    private function checkFileType ( $physicalname )
    {
    	$type = substr ( strrchr ( $physicalname, "." ), 1 ); // find type of file
    	if ( $type == "" || substr ( $type, 0, 3 ) == "php" || $type == "phtml" ) {
    	    return false;
    	} else {
    	    return true;
    	}
    } // end checkFileType

}

$Drive = new Drive ();
$page = $Drive -> page;
?>