<?php
/* **************************************************************************** *

 * cor-set-user.php								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing user settings

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class SetUser {

    public $page = array ( "text" => "" );

    public function __construct ()
    {

        if ( isset ( $_POST [ "openid" ] ) && $_POST [ "openid" ] != "" && $_POST [ "openid" ] != _( "Vaše OpenID" ) ) {
            $openid = new OpenID ();
            $openid -> SetIdentity ( $_POST [ "openid" ] );
            $openid -> SetTrustRoot ( "http://" . $_SERVER [ "HTTP_HOST" ] );
            if ($openid->GetOpenIDServer()) {
                $openid->SetApprovedURL("http://" . $_SERVER [ "HTTP_HOST" ] . substr ( $_SERVER [ "SCRIPT_NAME" ], 0, strrpos ( $_SERVER [ "SCRIPT_NAME" ], "/" ) ) ."/". Tools::getFullPage ());
                $openid->Redirect();
            } else {
                $error = $openid -> GetError ();
                $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Přihlášení pomocí OpenID selhalo:" )." ".$error [ "code" ]." - ".$error [ "description" ]."</strong></p>";
            }
        }
        if ( isset ( $_GET [ "openid_mode" ] ) && $_GET [ "openid_mode" ] == "id_res" ) {
            $openid = new OpenID();
            $openid -> SetIdentity ( $_GET [ "openid_identity" ] );
            if ( $openid -> ValidateWithServer () == true ) {
                if ( Database::connection () -> query ( "INSERT INTO openids (openid,userid) VALUES ('".urldecode($_GET [ "openid_identity" ])."',". User::session () -> getId () .");" ) ) {
                    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "Váš uživatelský účet byl úspěšně propojen s Vaší OpenID identitou." ) .'</strong></p>';
                } else {
                    $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Nepodařilo se uložit údaje o Vašem OpenID do databáze." ).'</strong></p>';
                }
            } elseif ( $openid -> IsError () == true ) {
                $error = $openid -> GetError ();
                $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Přihlášení pomocí OpenID selhalo:" )." ".$error [ "code" ]." - ".$error [ "description" ]."</strong></p>";
            }
        } elseif ( isset ( $_GET [ "openid_mode" ] ) && $_GET [ "openid_mode" ] == "cancel" ){
            $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Uživatel zrušil přihlašování." ).'</strong></p>';
        }
        if ( isset ( $_POST [ "fullname" ], $_POST [ "oldpass" ], $_POST [ "pass" ], $_POST [ "pass2" ], $_POST [ "language" ] )  ) {
    	    $this -> page [ "text" ] .= $this -> updateUser ();
    	} else {
    	    $this -> page [ "text" ] .= $this -> userDatabaseForm ();
    	}

    } // end __construct

    private function updateUser ()
    {
    	if ( empty ( $_POST [ "oldpass" ] ) ) {
    	    $fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	    $language = htmlspecialchars ( $_POST [ "language" ] );
    	    if ( Database::connection () -> query ( "UPDATE users SET fullname='$fullname', language='$language' WHERE id=". User::session () -> getId () .";" ) ) {
    	    	return '<p><strong class="success">'. User::session () -> getNick () . ' - '. _( "uživatel byl úspěšně upraven") .'.</strong></p>';
    	    } else {
    	    	return '<p><strong class="warning">'. User::session () -> getNick () . ' - '. _( "nepodařilo se změnit profil uživatele" ) .'!</strong></p>';
    	    }
    	} else {
    	    $fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	    $language = htmlspecialchars ( $_POST [ "language" ] );
    	    if ( $_POST [ "pass" ] != $_POST [ "pass2" ] ) {
    	    	return '<p><strong class="warning">'. _( "Nové heslo a ověření hesla se neshodují" ) .'!</strong></p>';
    	    }

    	    if ( strlen ( $_POST [ "pass" ] ) < 6 ) {
    	    	return '<p><strong class="warning">'. _( "Délka hesla musí být minimálně 6 znaků" ) .'!</strong></p>';
    	    }

	    $oldpass = md5 ( $_POST [ "oldpass" ] );
    	    if ( Database::connection () -> getResult ( "SELECT password FROM users WHERE id=". User::session () -> getId () .";" ) != $oldpass ) {
    	    	return '<p><strong class="warning">'. _( "Staré heslo je chybné" ) .'!</strong></p>';
    	    }

    	    $password = md5 ( $_POST [ "pass" ] );
    	    if ( Database::connection () -> query ( "UPDATE users SET fullname='$fullname', language='$language', password='$password' WHERE id=". User::session () -> getId () .";" ) ) {
    	    	return '<p><strong class="success">'. User::session () -> getNick () . ' - '. _( "uživatel a jeho heslo byli úspěšně upraveni") .'.</strong></p>';
    	    } else {
    	    	return '<p><strong class="warning">'. User::session () -> getNick () . ' - '. _( "nepodařilo se změnit profil uživatelea heslo" ) .'!</strong></p>';
    	    }
    	}
    } // end updateUser

    private function userDatabaseForm ()
    {

	$form = '<script type="text/javascript" src="scripts/cor-user-administration.js"></script>
	    <form action="'. Tools::getFullPage () .'" method="post" enctype="application/x-www-form-urlencoded">
	    	<fieldset>
     	    	    <legend>'. _( "Upravit profil" ) .'</legend>
     	    	    <img src="images/users-icons/free-icons/blue-user-big.jpg" alt="blue user icon" class="floatLeft" />
     	    	    <div class="cor-greatIconLeft">
     	    	    <label for="fullname">'. _( "Občanské jméno" ) .': </label><input type="text" id="fullname" name="fullname" maxlength="40" value="'. User::session () -> getFullName () .'" /><br />
     	    	    <label for="language">'. ( "Jazyk" ) .': </label><select name="language" id="language">
             	    	<option value="cs"'. ( ( User::session () -> getLanguage () == "cs" ) ? " selected=\"selected\"" : "" ) .'>čeština</option>
             	    </select><br />
             	    <label for="oldpass">'. _( "Staré heslo" ) .': </label><input type="password" size="15" id="oldpass" name="oldpass" maxlength="25" /><br />
             	    <label for="pass">'. _( "Nové heslo" ) .': </label><input type="password" size="15" id="pass" name="pass" maxlength="25" onkeyup="passwordStrength(this.value,\'passwordStrength\');" /><br />
             	    <span id="passwordStrength" class="floatLeft">'. _( "Zde bude zobrazeno hodnocení nového hesla" ) .'</span><br />
             	    <label for="pass2">'. _( "Ověření hesla" ) .': </label><input type="password" size="15" id="pass2" name="pass2" maxlength="25" /><br />
             	    <input class="dialoguebutton" type="submit" value="'. ( "Uložit změny" ) .'" />
             	    </div>
             	</fieldset>
	    </form>';

	$usergroups = Database::connection () -> fetchall_assoc ( "SELECT usergroup FROM usergroups WHERE id=". User::session () -> getId () .";" );
    $openids = Database::connection () -> fetchall_assoc ( "SELECT openid FROM openids WHERE userid=". User::session () -> getId () .";" );
	$form .= "<p>". _( "Patříte do skupin:" ) ." ";
	foreach ( $usergroups as $group ) {
	    $form .= "<strong>". $group [ "usergroup" ] ."</strong>,";
	}
    $form = substr ( $form, 0, -1 ) . "</p><p>". _( "Příslušnost do skupin mohou určovat pouze administrátoři a webmasteři." ) ."</p>";

    $form .= '<script type="text/javascript" src="scripts/cor-form-default-text.js"></script>
            <form action="'. Tools::getFullPage () .'" method="post" enctype="application/x-www-form-urlencoded">
     	    	<fieldset>
                    <legend>'. _( "Spojit účet s OpenID" ) .'</legend>
                    <img class="objectLeft" src="styles/cor-admin/openid.gif" alt="openid" />
                    <label for="openid">'. _( "Vaše OpenID" ) .': </label><input type="text" size="15" id="openid" maxlength="255" name="openid" value="'. _( "Vaše OpenID" ) .'" onfocus="onFocusFormDefaultText(\''. _( "Vaše OpenID" ) .'\',this);" onblur="onLostFocusFormDefaultText(\''. _( "Vaše OpenID" ) .'\',this);" /><br />
             	    <br /><input class="dialoguebutton" type="submit" value="'. _( "Spojit" ) .'" />
                    <br /><br /><a href="http://www.openid.cz/">'. _( "Získejte OpenID" ) .'</a><br />
                    <a href="http://www.albireo.eu/openid" title="Albireo.eu">'. _( "Informace o OpenID na Albireo.eu" ) .'</a>
                </fieldset>
            </form>';

    $form .= "<p>". _( "Přiřazená OpenID:" ) ."<br />";
	foreach ( $openids as $openid ) {
	    $form .= "<strong>". $openid [ "openid" ] ."</strong><br />";
	}
	$form .= "</p>";

	return $form.'<script type="text/javascript">dialogueButtons();</script>';
    
    } // end userDatabaseForm

}

$SetUser = new SetUser ();
$page = $SetUser -> page;
?>