<?php
/* **************************************************************************** *

 * cor-visitors-stats.php							*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page with statistics of web pages using Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage

 Public Methods:
    none

 * **************************************************************************** */

class VisitorsStats {

    public $page = array ( "text" => "" );
    private $year = 0;
    private $month = 0;
    private $day = 0;
    private $months = array ();

    public function __construct ()
    {

        $this -> months [ 1 ] = _( "Leden" );
        $this -> months [ 2 ] = _( "Únor" );
        $this -> months [ 3 ] = _( "Březen" );
        $this -> months [ 4 ] = _( "Duben" );
        $this -> months [ 5 ] = _( "Květen" );
        $this -> months [ 6 ] = _( "Červen" );
        $this -> months [ 7 ] = _( "Červenec" );
        $this -> months [ 8 ] = _( "Srpen" );
        $this -> months [ 9 ] = _( "Září" );
        $this -> months [ 10 ] = _( "Říjen" );
        $this -> months [ 11 ] = _( "Listopad" );
        $this -> months [ 12 ] = _( "Prosinec" );

        if ( isset ( $_GET [ "action" ] ) ) {
            switch ( $_GET [ "action" ] ) {
                default:
                    $xmllog = new XMLLog();
                    $xmllog -> findXMLLogs();
                    $this -> overView ();
            }
        } else {
            $xmllog = new XMLLog();
            $xmllog -> findXMLLogs();
            $this -> overView ();
        }

    } // end __construct

    private function overView ()
    {
        $this -> year = ( isset ( $_GET [ "year" ] ) ) ? (int) $_GET [ "year" ] : date ( "Y" );
        $this -> month = ( isset ( $_GET [ "month" ] ) ) ? (int) $_GET [ "month" ] : date ( "n" );

        $this -> page [ "title" ] = _( "Statistiky pro" ) ." ". $this -> months [ $this -> month ] ." ". $this -> year;
        $this -> page [ "text" ] = '<p>'. _( "Tyto statistiky slouží pouze pro základní přehled o návštěvnících webu za poslední měsíc.
        Pro podrobnější statistiky doporučujeme použít Google Analytics:" ) .'<br /><a href="http://www.albireo.eu/openid" title="Albireo.eu">'. _( "Návod pro Google Analytics na Albireo.eu" ) .'</a></p>';
        $this -> page [ "text" ] .= '<table class="table">
            <caption>'. _( "Přehled za měsíc" ) .'</caption>
            <tr><th>'. _( "Celkem zobrazení:" ) .'</th><td>'. Database::connection () -> getResult ( "SELECT COUNT(*) FROM visitorsstats WHERE month=". $this -> month ." AND year=". $this -> year .";" ) .'</td></tr>
            <tr><th>'. _( "Unikátních IP adres:" ) .'</th><td>'. Database::connection () -> getResult ( "SELECT COUNT(DISTINCT ipaddress) FROM visitorsstats WHERE month=". $this -> month ." AND year=". $this -> year .";" ) .'</td></tr>
        </table>';

        $stats_per_day = Database::connection()->fetchall_assoc("SELECT day, COUNT(DISTINCT ipaddress) as visitors, COUNT(*) as pages FROM visitorsstats WHERE month=". $this -> month ." AND year=". $this -> year ." GROUP BY day;");
        $this -> page [ "text" ] .= '<table class="table">
            <caption>'. _( "Denní statistika" ) .'</caption>
            <tr><th>'. _( "den" ) .'</th><th>'. _( "návštěvníků" ) .'</th><th>'. _( "stránek" ) .'</th></tr>';
        foreach ($stats_per_day as $stat) {
            $this -> page [ "text" ] .= '<tr><td>'. $stat [ "day" ] .'</td><td>'. $stat [ "visitors" ] .'</td><td>'. $stat [ "pages" ] .'</td></tr>';
        }
        $this -> page [ "text" ] .= '</table>';

        $stats_per_page = Database::connection()->fetchall_assoc("SELECT page, COUNT(DISTINCT ipaddress) as visitors, COUNT(*) as pages FROM visitorsstats WHERE month=". $this -> month ." AND year=". $this -> year ." GROUP BY page ORDER BY COUNT(*) DESC;");
        $this -> page [ "text" ] .= '<table class="table" style="text-align:left;">
            <caption>'. _( "Statistika návštěvnosti stránek" ) .'</caption>
            <tr><th>'. _( "stránka" ) .'</th><th>'. _( "návštěvníků" ) .'</th><th>'. _( "zobrazeno" ) .'</th></tr>';
        foreach ($stats_per_page as $stat) {
            $this -> page [ "text" ] .= '<tr><td>'. $stat [ "page" ] .'</td><td>'. $stat [ "visitors" ] .'</td><td>'. $stat [ "pages" ] .'</td></tr>';
        }
        $this -> page [ "text" ] .= '</table>';
    } // end overView   

}

$VisitorsStats = new VisitorsStats ();
$page = $VisitorsStats -> page;
?>